Index: issm/branches/trunk-jpl-damage/src/m/classes/pairoptions.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/pairoptions.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/pairoptions.py	(revision 12878)
@@ -1,38 +1,213 @@
-class pairoptions:
-	#properties
-	def __init__(self,*args):
-		# {{{ Properties
-		if len(args)%2==1:
-			raise RuntimeError('pairoption error message: an even number of options is required')
-
-		#create a pairoption object
-		if len(args)==0:
-			self.list=[]
-		else:
-			self.list=[]
-			for i in range(int(round(len(args)/2))):
-				if isinstance(args[2*i],str):
-					self.list.append([args[2*i],args[2*i+1]])
+from WriteData import *
+
+class pairoptions(object):
+	"""
+	PAIROPTIONS class definition
+ 
+	    Usage:
+	       pairoptions=pairoptions();
+	       pairoptions=pairoptions('module',true,'solver',false);
+	"""
+
+	def __init__(self,*arg):
+		self.functionname = ''
+		self.list         = {}
+
+		#get calling function name
+		import inspect
+		if len(inspect.stack()) > 1:
+			self.functionname=inspect.stack()[1][3]
+
+		#initialize list
+		if not len(arg):
+			pass    #Do nothing,
+		else:
+			self.buildlist(*arg)
+	# }}}
+
+	def buildlist(self,*arg):    # {{{
+		"""BUILDLIST - build list of objects from input"""
+
+		#check length of input
+		if len(arg) % 2:
+			raise TypeError('error: an even number of options is required') 
+		numoptions = len(arg)/2
+
+		#go through arg and build list of objects
+		for i in xrange(numoptions):
+			if isinstance(arg[2*i],str):
+				self.list[arg[2*i]] = arg[2*i+1];
+			else:
+				#option is not a string, ignore it
+				print "WARNING: option number %d '%s' is not a string and will be ignored." % (i+1,type(arg[2*i]))
+	# }}}
+
+	def addfield(self,field,value):    # {{{
+		"""ADDFIELD - add a field to an options list"""
+		if isinstance(field,str):
+			if field in self.list:
+				print "WARNING: field '%s' with value=%s exists and will be overwritten with value=%s." % (field,str(self.list[field]),str(value))
+			self.list[field] = value
+	# }}}
+
+	def addfielddefault(self,field,value):    # {{{
+		"""ADDFIELDDEFAULT - add a field to an options list if it does not exist"""
+		if isinstance(field,str):
+			if not field in self.list:
+				self.list[field] = value
+	# }}}
+
+	def AssignObjectFields(self,obj2):    # {{{
+		"""ASSIGNOBJECTFIELDS - assign object fields from options"""
+		for item in self.list.iteritems():
+			if item[0] in dir(obj2):
+				setattr(obj2,item[0],item[1])
+			else:
+				print "WARNING: field '%s' is not a property of '%s'." % (item[0],type(obj2))
+		return obj2
+	# }}}
+
+	def changefieldvalue(self,field,newvalue):    # {{{
+		"""CHANGEOPTIONVALUE - change the value of an option in an option list"""
+
+		self.list[field]=newvalue;
+	# }}}
+
+#	function obj = deleteduplicates(obj,warn) % {{{
+#	%DELETEDUPLICATES - delete duplicates in an option list
+#
+#		%track the first occurance of each option
+#		[dummy lines]=unique(obj.list(:,1),'first');
+#		clear dummy
+#
+#		%warn user if requested
+#		if warn,
+#			numoptions=size(obj.list,1);
+#			for i=1:numoptions,
+#				if ~ismember(i,lines),
+#					disp(['WARNING: option ' obj.list{i,1} ' appeared more than once. Only its first occurence will be kept'])
+#				end
+#			end
+#		end
+#
+#		%remove duplicates from the options list
+#		obj.list=obj.list(lines,:);
+#	end % }}}
+
+	def __repr__(self):    # {{{
+		s="   functionname: '%s'\n" % self.functionname
+		if self.list:
+			s+="   list: (%ix%i)\n\n" % (len(self.list),2)
+			for item in self.list.iteritems():
+				if   isinstance(item[1],str):
+					s+="     field: %-10s value: '%s'\n" % (item[0],item[1])
+				elif isinstance(item[1],(bool,int,long,float)):
+					s+="     field: %-10s value: %g\n" % (item[0],item[1])
 				else:
-					#option is not a string, ignore it
-					print("%s%i%s"%('buildlist info: option number ',i,' is not a string, it will be ignored'))
-					continue
-
-		#}}}
-	def __repr__(obj):
-		# {{{ Display
-		if not obj.list:
-			string='   list: empty'
-		else:
-			string="   list: (%i)"%(len(obj.list))
-			for i in range(len(obj.list)):
-				if isinstance(obj.list[i][1],str):
-					string2="     field: %-10s value: '%s'"%(obj.list[i][0],obj.list[i][1])
-				elif isinstance(obj.list[i][1],float):
-					string2="     field: %-10s value: %g"%(obj.list[i][0],obj.list[i][1])
-				elif isinstance(obj.list[i][1],int):
-					string2="     field: %-10s value: %i"%(obj.list[i][0],obj.list[i][1])
-				else:
-					string2="     field: %-10s value: (%i)"%(len(obj.list[i][1]))
-				string="%s\n%s"%(string,string2)
-		return string
+					s+="     field: %-10s value: %s\n" % (item[0],type(item[1]))
+		else:
+			s+="   list: empty\n"
+		return s
+	# }}}
+
+	def exist(self,field):    # {{{
+		"""EXIST - check if the option exist"""
+
+		#some argument checking: 
+		if field == None or field == '':
+			raise ValueError('exist error message: bad usage');
+		if not isinstance(field,str):
+			raise TypeError("exist error message: field '%s' should be a string." % str(field));
+
+		#Recover option
+		if field in self.list:
+			return True
+		else:
+			return False
+	# }}}
+
+#	function num = fieldoccurences(obj,field), % {{{
+#	%FIELDOCCURENCES - get number of occurence of a field
+#
+#		%check input 
+#		if ~ischar(field),
+#			error('fieldoccurences error message: field should be a string');
+#		end
+#
+#		%get number of occurence
+#		num=sum(strcmpi(field,obj.list(:,1)));
+#	end % }}}
+
+	def getfieldvalue(self,field,default=None):    # {{{
+		"""
+		GETOPTION - get the value of an option
+	
+		Usage:
+		   value=options.getfieldvalue(field,default)
+	 
+		Find an option value from a field. A default option
+		can be given in input if the field does not exist
+	 
+		Examples:
+		   value=options.getfieldvalue(options,'caxis')
+		   value=options.getfieldvalue(options,'caxis',[0 2])
+		"""
+
+		#some argument checking: 
+		if field == None or field == '':
+			raise ValueError('getfieldvalue error message: bad usage');
+		if not isinstance(field,str):
+			raise TypeError("getfieldvalue error message: field '%s' should be a string." % str(field));
+
+		#Recover option
+		if field in self.list:
+			value=self.list[field]
+		else:
+			if not default == None:
+				value=default
+			else:
+				raise KeyError("error message: field '%s' has not been provided by user (and no default value has been specified)." % field)
+
+		return value
+	# }}}
+
+	def removefield(self,field,warn):    # {{{
+		"""
+		REMOVEFIELD - delete a field in an option list
+	 
+		Usage:
+		   obj=removefield(self,field,warn)
+	 
+		if warn==1 display an info message to warn user that
+		some of his options have been removed.
+		"""
+
+		#check if field exist
+		if field in self.list:
+
+			#remove duplicates from the options list
+			del self.list[field]
+
+			#warn user if requested
+			if warn:
+				print "removefield info: option '%s' has been removed from the list of options." % field
+	# }}}
+
+	def marshall(self,fid,firstindex):    # {{{
+
+		for i,item in enumerate(self.list.iteritems()):
+			name  = item[0]
+			value = item[1]
+
+			#Write option name
+			WriteData(fid,'enum',(firstindex-1)+2*i+1,'data',name,'format','String')
+
+			#Write option value
+			if   isinstance(value,str):
+				WriteData(fid,'enum',(firstindex-1)+2*i+2,'data',value,'format','String')
+			elif isinstance(value,(bool,int,long,float)):
+				WriteData(fid,'enum',(firstindex-1)+2*i+2,'data',value,'format','Double')
+			else:
+				raise TypeError("Cannot marshall option '%s': format not supported yet." % name)
+	# }}}
+
Index: issm/branches/trunk-jpl-damage/src/m/classes/plotoptions.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/plotoptions.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/plotoptions.m	(revision 12878)
@@ -6,5 +6,5 @@
 classdef plotoptions
     properties (SetAccess=public) 
-		 % {{{1
+		 % {{{
 		 numberofplots = 0;
 		 figurenumber  = 1;
@@ -13,9 +13,9 @@
 	 end
 	 methods
-		 function opt=plotoptions(varargin) % {{{1
+		 function opt=plotoptions(varargin) % {{{
 			 opt=buildlist(opt,varargin{:});
 		 end
 		 %}}}
-		 function disp(opt) % {{{1
+		 function disp(opt) % {{{
 			 disp(sprintf('\n%s = \n',inputname(1)));
 			 disp(sprintf('   numberofplots: %i',opt.numberofplots));
@@ -41,5 +41,5 @@
 		 end
 		 %}}}
-		 function opt=buildlist(opt,varargin) % {{{1
+		 function opt=buildlist(opt,varargin) % {{{
 
 			 %check length of input
Index: issm/branches/trunk-jpl-damage/src/m/classes/private.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/private.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/private.m	(revision 12878)
@@ -6,7 +6,8 @@
 classdef private
 	properties (SetAccess=public) 
-		 runtimename = '';
-		 bamg        = struct();
-		 solution    = '';
+		isconsistent = true;
+		runtimename  = '';
+		bamg         = struct();
+		solution     = '';
 	end
 	methods
@@ -22,5 +23,5 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 		end % }}}
@@ -28,4 +29,5 @@
 			disp(sprintf('   private parameters: do not change'));
 
+			fielddisplay(obj,'isconsistent','is model self consistent');
 			fielddisplay(obj,'runtimename','name of the run launched');
 			fielddisplay(obj,'bamg','structure with mesh properties construced if bamg is used to mesh the domain');
Index: issm/branches/trunk-jpl-damage/src/m/classes/prognostic.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/prognostic.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/prognostic.m	(revision 12878)
@@ -36,13 +36,13 @@
 			obj.hydrostatic_adjustment='Absolute';
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return,
 			if ~ismember(PrognosticAnalysisEnum,analyses) |  (solution==TransientSolutionEnum & md.transient.isprognostic==0), return; end
 
-			checkfield(md,'prognostic.spcthickness','forcing',1);
-			checkfield(md,'prognostic.hydrostatic_adjustment','values',{'Absolute' 'Incremental'});
-			checkfield(md,'prognostic.stabilization','values',[0 1 2 3]);
-			checkfield(md,'prognostic.min_thickness','>',0);
+			md = checkfield(md,'prognostic.spcthickness','forcing',1);
+			md = checkfield(md,'prognostic.hydrostatic_adjustment','values',{'Absolute' 'Incremental'});
+			md = checkfield(md,'prognostic.stabilization','values',[0 1 2 3]);
+			md = checkfield(md,'prognostic.min_thickness','>',0);
 
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/qmu.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/qmu.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/qmu.m	(revision 12878)
@@ -35,5 +35,5 @@
 	
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
@@ -41,27 +41,27 @@
 
 			if md.qmu.params.evaluation_concurrency~=1,
-				checkmessage(['concurrency should be set to 1 when running dakota in library mode']);
+				md = checkmessage(md,['concurrency should be set to 1 when running dakota in library mode']);
 			end
 			if ~isempty(md.qmu.partition),
 				if numel(md.qmu.partition)~=md.mesh.numberofvertices,
-					checkmessage(['user supplied partition for qmu analysis should have size md.mesh.numberofvertices x 1 ']);
+					md = checkmessage(md,['user supplied partition for qmu analysis should have size md.mesh.numberofvertices x 1 ']);
 				end
 				if find(md.qmu.partition)>=md.mesh.numberofvertices,
-					checkmessage(['user supplied partition should be indexed from 0 (c-convention)']);
+					md = checkmessage(md,['user supplied partition should be indexed from 0 (c-convention)']);
 				end
 				if min(md.qmu.partition)~=0,
-					checkmessage(['partition vector not indexed from 0 on']);
+					md = checkmessage(md,['partition vector not indexed from 0 on']);
 				end
 				if max(md.qmu.partition)>=md.mesh.numberofvertices,
-					checkmessage(['partition vector cannot have maximum index larger than number of nodes']);
+					md = checkmessage(md,['partition vector cannot have maximum index larger than number of nodes']);
 				end
 				if ~isempty(find(md.qmu.partition<0)),
-					checkmessage(['partition vector cannot have values less than 0']);
+					md = checkmessage(md,['partition vector cannot have values less than 0']);
 				end
 				if ~isempty(find(md.qmu.partition>=md.qmu.numberofpartitions)),
-					checkmessage(['partition vector cannot have values more than md.qmu.numberofpartitions-1']);
+					md = checkmessage(md,['partition vector cannot have values more than md.qmu.numberofpartitions-1']);
 				end
 				if max(md.qmu.partition)>=md.qmu.numberofpartitions,
-					checkmessage(['for qmu analysis, partitioning vector cannot go over npart, number of partition areas']);
+					md = checkmessage(md,['for qmu analysis, partitioning vector cannot go over npart, number of partition areas']);
 				end
 			end
@@ -69,5 +69,5 @@
 			if ~strcmpi(md.cluster.name,'none'),
 				if md.settings.waitonlock==0,
-					checkmessage(['waitonlock should be activated when running qmu in parallel mode!']);
+					md = checkmessage(md,['waitonlock should be activated when running qmu in parallel mode!']);
 				end
 			end
Index: issm/branches/trunk-jpl-damage/src/m/classes/rifts.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/rifts.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/rifts.m	(revision 12878)
@@ -21,5 +21,5 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 			if isempty(obj.riftstruct) | isnans(obj.riftstruct),
 				numrifts=0;
@@ -29,17 +29,17 @@
 			if numrifts,
 				if ~(md.mesh.dimension==2),
-					checkmessage(['models with rifts are only supported in 2d for now!']);
+					md = checkmessage(md,['models with rifts are only supported in 2d for now!']);
 				end
 				if ~isstruct(obj.riftstruct),
-					checkmessage(['rifts.riftstruct should be a structure!']);
+					md = checkmessage(md,['rifts.riftstruct should be a structure!']);
 				end
 				if ~isempty(find(md.mesh.segmentmarkers>=2)),
 					%We have segments with rift markers, but no rift structure!
-					checkmessage(['model should be processed for rifts (run meshprocessrifts)!']);
+					md = checkmessage(md,['model should be processed for rifts (run meshprocessrifts)!']);
 				end
-				checkfield(md,'rifts.riftstruct.fill','values',[WaterEnum() AirEnum() IceEnum() MelangeEnum()]);
+				md = checkfield(md,'rifts.riftstruct.fill','values',[WaterEnum() AirEnum() IceEnum() MelangeEnum()]);
 			else
 				if ~isnans(obj.riftstruct),
-					checkmessage(['riftstruct shoud be NaN since numrifts is 0!']);
+					md = checkmessage(md,['riftstruct shoud be NaN since numrifts is 0!']);
 				end
 			end
Index: issm/branches/trunk-jpl-damage/src/m/classes/settings.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/settings.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/settings.m	(revision 12878)
@@ -41,11 +41,11 @@
 			obj.waitonlock=Inf;
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
-			checkfield(md,'settings.io_gather','numel',1,'values',[0 1]);
-			checkfield(md,'settings.lowmem','numel',1,'values',[0 1]);
-			checkfield(md,'settings.results_as_patches','numel',1,'values',[0 1]);
-			checkfield(md,'settings.output_frequency','numel',1,'>=',1);
-			checkfield(md,'settings.waitonlock','numel',1);
+			md = checkfield(md,'settings.io_gather','numel',1,'values',[0 1]);
+			md = checkfield(md,'settings.lowmem','numel',1,'values',[0 1]);
+			md = checkfield(md,'settings.results_as_patches','numel',1,'values',[0 1]);
+			md = checkfield(md,'settings.output_frequency','numel',1,'>=',1);
+			md = checkfield(md,'settings.waitonlock','numel',1);
 
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/solver.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/solver.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/solver.m	(revision 12878)
@@ -18,5 +18,5 @@
 				 end
 			 end % }}}
-		 function obj = addoptions(obj,analysis,varargin) % {{{1
+		 function obj = addoptions(obj,analysis,varargin) % {{{
 		 % Usage example:
 		 %    md.solver=addoptions(md.solver,DiagnosticHorizAnalysisEnum,stokesoptions());
@@ -54,9 +54,9 @@
 			 end
 		 end % }}}
-		 function checkconsistency(obj,md,solution,analyses) % {{{
+		 function md = checkconsistency(obj,md,solution,analyses) % {{{
 			 analyses=properties(obj);
 			 for i=1:numel(analyses),
 				 if isempty(fieldnames(obj.(analyses{i})))
-					 checkmessage(['md.solver.' analyses{i} ' is empty']);
+					 md = checkmessage(md,['md.solver.' analyses{i} ' is empty']);
 				 end
 			 end
Index: issm/branches/trunk-jpl-damage/src/m/classes/steadystate.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/steadystate.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/steadystate.m	(revision 12878)
@@ -26,5 +26,5 @@
 			obj.reltol=0.01;
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
@@ -32,9 +32,9 @@
 
 			if md.timestepping.time_step~=0,
-				checkmessage(['for a steadystate computation, timestepping.time_step must be zero.']);
+				md = checkmessage(md,['for a steadystate computation, timestepping.time_step must be zero.']);
 			end
 
 			if isnan(md.diagnostic.reltol),
-				checkmessage(['for a steadystate computation, diagnostic.reltol (relative convergence criterion) must be defined!']);
+				md = checkmessage(md,['for a steadystate computation, diagnostic.reltol (relative convergence criterion) must be defined!']);
 			end
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/surfaceforcings.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/surfaceforcings.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/surfaceforcings.m	(revision 12878)
@@ -8,4 +8,20 @@
 		precipitation = NaN;
 		mass_balance  = NaN;
+		ispdd = 0;
+		issmbgradients = 0;
+		isdelta18o = 0;
+	   hc = NaN;
+		smb_pos_max = NaN;
+		smb_pos_min = NaN;
+		a_pos = NaN;
+		b_pos = NaN;
+		a_neg = NaN;
+		b_neg = NaN;
+		monthlytemperatures = NaN;
+		delta18o = NaN;
+		delta18o_surface = NaN;
+		temperatures_presentday = NaN;
+		temperatures_lgm = NaN;
+		precipitations_presentday = NaN;
 	end
 	methods
@@ -19,13 +35,41 @@
 		end % }}}
 		function obj = setdefaultparameters(obj) % {{{
+		  
+		  %pdd method not used in default mode
+		  obj.ispdd=0;
+		  obj.issmbgradients=0;
+		  obj.isdelta18o=0;
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			if ismember(PrognosticAnalysisEnum,analyses),
-				checkfield(md,'surfaceforcings.mass_balance','forcing',1,'NaN',1);
+				md = checkfield(md,'surfaceforcings.ispdd','numel',1,'values',[0 1]);
+				checkfield(md,'surfaceforcings.issmbgradients','numel',1,'values',[0 1]);
+				if(obj.ispdd)
+				        if(obj.isdelta18o==0)
+				        	md = checkfield(md,'surfaceforcings.monthlytemperatures','forcing',1,'NaN',1);
+				        	md = checkfield(md,'surfaceforcings.precipitation','forcing',1,'NaN',1);
+			                else
+				                md = checkfield(md,'surfaceforcings.delta18o','NaN',1);
+				        	md = checkfield(md,'surfaceforcings.delta18o_surface','NaN',1);
+				        	md = checkfield(md,'surfaceforcings.temperatures_presentday','size',[md.mesh.numberofvertices+1 12],'NaN',1);
+				        	md = checkfield(md,'surfaceforcings.temperatures_lgm','size',[md.mesh.numberofvertices+1 12],'NaN',1);
+				        	md = checkfield(md,'surfaceforcings.precipitations_presentday','size',[md.mesh.numberofvertices+1 12],'NaN',1);
+				        end
+				elseif(obj.issmbgradients)
+					checkfield(md,'surfaceforcings.hc','forcing',1,'NaN',1);
+					checkfield(md,'surfaceforcings.smb_pos_max','forcing',1,'NaN',1);
+					checkfield(md,'surfaceforcings.smb_pos_min','forcing',1,'NaN',1);
+					checkfield(md,'surfaceforcings.a_pos','forcing',1,'NaN',1);
+					checkfield(md,'surfaceforcings.b_pos','forcing',1,'NaN',1);
+					checkfield(md,'surfaceforcings.a_neg','forcing',1,'NaN',1);
+					checkfield(md,'surfaceforcings.b_neg','forcing',1,'NaN',1);
+				else
+					md = checkfield(md,'surfaceforcings.mass_balance','forcing',1,'NaN',1);
+				end
 			end
 			if ismember(BalancethicknessAnalysisEnum,analyses),
-				checkfield(md,'surfaceforcings.mass_balance','size',[md.mesh.numberofvertices 1],'NaN',1);
+				md = checkfield(md,'surfaceforcings.mass_balance','size',[md.mesh.numberofvertices 1],'NaN',1);
 			end
 		end % }}}
@@ -33,6 +77,22 @@
 			disp(sprintf('   surface forcings parameters:'));
 
+			fielddisplay(obj,'mass_balance','surface mass balance [m/yr ice eq]');
+			fielddisplay(obj,'ispdd','is pdd activated (0 or 1, default is 0)');
+			fielddisplay(obj,'isdelta18o','is temperature and precipitation delta18o parametrisation activated (0 or 1, default is 0)');
+			fielddisplay(obj,'monthlytemperatures','monthly surface temperatures [Kelvin], required if pdd is activated and delta18o not activated');
 			fielddisplay(obj,'precipitation','surface precipitation [m/yr water eq]');
-			fielddisplay(obj,'mass_balance','surface mass balance [m/yr ice eq]');
+			fielddisplay(obj,'temperatures_presentday','monthly present day surface temperatures [Kelvin], required if pdd is activated and delta18o activated');
+			fielddisplay(obj,'temperatures_lgm','monthly LGM surface temperatures [Kelvin], required if pdd is activated and delta18o activated');
+			fielddisplay(obj,'precipitations_presentday','monthly surface precipitation [m/yr water eq], required if pdd is activated and delta18o activated');
+			fielddisplay(obj,'delta18o','delta18o, required if pdd is activated and delta18o activated');
+			fielddisplay(obj,'delta18o_surface','surface elevation of the delta18o site, required if pdd is activated and delta18o activated');
+			fielddisplay(obj,'issmbgradients','is smb gradients method activated (0 or 1, default is 0)');
+			fielddisplay(obj,'hc',' elevation of intersection between accumulation and ablation regime required if smb gradients is activated');
+			fielddisplay(obj,'smb_pos_max',' maximum value of positive smb required if smb gradients is activated');
+			fielddisplay(obj,'smb_pos_min',' minimum value of positive smb required if smb gradients is activated');
+			fielddisplay(obj,'a_pos',' intercept of hs - smb regression line for accumulation regime required if smb gradients is activated');
+			fielddisplay(obj,'b_pos',' slope of hs - smb regression line for accumulation regime required if smb gradients is activated');
+			fielddisplay(obj,'a_neg',' intercept of hs - smb regression line for ablation regime required if smb gradients is activated');
+			fielddisplay(obj,'b_neg',' slope of hs - smb regression line for ablation regime required if smb gradients is activated');
 
 		end % }}}
@@ -40,4 +100,29 @@
 			WriteData(fid,'object',obj,'fieldname','precipitation','format','DoubleMat','mattype',1);
 			WriteData(fid,'object',obj,'fieldname','mass_balance','format','DoubleMat','mattype',1);
+			WriteData(fid,'object',obj,'fieldname','ispdd','format','Boolean');
+			WriteData(fid,'object',obj,'fieldname','isdelta18o','format','Boolean');
+			if obj.ispdd,
+			  if obj.isdelta18o
+			        WriteData(fid,'object',obj,'fieldname','temperatures_presentday','format','DoubleMat','mattype',1);
+			        WriteData(fid,'object',obj,'fieldname','temperatures_lgm','format','DoubleMat','mattype',1);
+			        WriteData(fid,'object',obj,'fieldname','precipitations_presentday','format','DoubleMat','mattype',1);
+			        WriteData(fid,'object',obj,'fieldname','delta18o_surface','format','DoubleMat','mattype',1);
+			        WriteData(fid,'object',obj,'fieldname','delta18o','format','DoubleMat','mattype',1);
+			  else
+				WriteData(fid,'object',obj,'fieldname','monthlytemperatures','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','precipitation','format','DoubleMat','mattype',1);
+			  end
+			end
+			WriteData(fid,'object',obj,'fieldname','issmbgradients','format','Boolean');
+			if obj.issmbgradients,
+				WriteData(fid,'object',obj,'fieldname','hc','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','smb_pos_max','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','smb_pos_min','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','a_pos','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','b_pos','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','a_neg','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','b_neg','format','DoubleMat','mattype',1);
+			end
+
 		end % }}}
 	end
Index: issm/branches/trunk-jpl-damage/src/m/classes/thermal.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/thermal.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/thermal.m	(revision 12878)
@@ -40,14 +40,14 @@
 			obj.isenthalpy=0;
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
 			if (~ismember(ThermalAnalysisEnum,analyses) & ~ismember(EnthalpyAnalysisEnum,analyses)) | (solution==TransientSolutionEnum & md.transient.isthermal==0), return; end
 
-			checkfield(md,'thermal.stabilization','numel',1,'values',[0 1 2]);
-			checkfield(md,'thermal.spctemperature','forcing',1);
-			if (ismember(EnthalpyAnalysisEnum,analyses) & md.thermal.isenthalpy),
-			checkfield(md,'thermal.spctemperature','<',md.materials.meltingpoint-md.materials.beta*md.materials.rho_ice*md.constants.g*md.geometry.thickness,'message','spctemperature should be below the adjusted melting point');
-			checkfield(md,'thermal.isenthalpy','numel',1,'values',[0 1]);
+			md = checkfield(md,'thermal.stabilization','numel',1,'values',[0 1 2]);
+			md = checkfield(md,'thermal.spctemperature','forcing',1);
+			if (ismember(EnthalpyAnalysisEnum,analyses) & md.thermal.isenthalpy & md.mesh.dimension==3),
+			md = checkfield(md,'thermal.spctemperature','<',md.materials.meltingpoint-md.materials.beta*md.materials.rho_ice*md.constants.g*(md.geometry.surface-md.mesh.z),'message','spctemperature should be below the adjusted melting point');
+			md = checkfield(md,'thermal.isenthalpy','numel',1,'values',[0 1]);
 			end
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/timestepping.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/timestepping.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/timestepping.m	(revision 12878)
@@ -33,13 +33,13 @@
 			obj.cfl_coefficient=.5;
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
-			checkfield(md,'timestepping.start_time','numel',1,'NaN',1);
-			checkfield(md,'timestepping.final_time','numel',1,'NaN',1);
-			checkfield(md,'timestepping.time_step','numel',1,'>=',0,'NaN',1);
-			checkfield(md,'timestepping.time_adapt','numel',1,'values',[0 1]);
-			checkfield(md,'timestepping.cfl_coefficient','numel',1,'>',0,'<=',1);
+			md = checkfield(md,'timestepping.start_time','numel',1,'NaN',1);
+			md = checkfield(md,'timestepping.final_time','numel',1,'NaN',1);
+			md = checkfield(md,'timestepping.time_step','numel',1,'>=',0,'NaN',1);
+			md = checkfield(md,'timestepping.time_adapt','numel',1,'values',[0 1]);
+			md = checkfield(md,'timestepping.cfl_coefficient','numel',1,'>',0,'<=',1);
 			if obj.final_time-obj.start_time<0,
-				checkmessage('timestepping.final_time should be larger than timestepping.start_time');
+				md = checkmessage(md,'timestepping.final_time should be larger than timestepping.start_time');
 			end 
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/transient.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/transient.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/transient.m	(revision 12878)
@@ -30,13 +30,14 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
 			if solution~=TransientSolutionEnum, return; end
 
-			checkfield(md,'transient.isprognostic','numel',1,'values',[0 1]);
-			checkfield(md,'transient.isdiagnostic','numel',1,'values',[0 1]);
-			checkfield(md,'transient.isthermal','numel',1,'values',[0 1]);
-			checkfield(md,'transient.isgroundingline','numel',1,'values',[0 1]);
+			md = checkfield(md,'transient.isprognostic','numel',1,'values',[0 1]);
+			md = checkfield(md,'transient.isdiagnostic','numel',1,'values',[0 1]);
+			md = checkfield(md,'transient.isthermal','numel',1,'values',[0 1]);
+			md = checkfield(md,'transient.isgroundingline','numel',1,'values',[0 1]);
+			md = checkfield(md,'transient.requested_outputs','size',[NaN 1]);
 
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/verbose.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/verbose.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/verbose.m	(revision 12878)
@@ -21,5 +21,5 @@
 classdef verbose
 	properties (SetAccess=public) 
-		% {{{1
+		% {{{
 		%BEGINFIELDS
 		mprocessor  = false;
@@ -35,5 +35,5 @@
 	%}}}
 	methods
-		function verbose=verbose(varargin) % {{{1
+		function verbose=verbose(varargin) % {{{
 
 			switch(nargin),
@@ -70,5 +70,5 @@
 		end
 		%}}}
-		function binary=VerboseToBinary(verbose) % {{{1
+		function binary=VerboseToBinary(verbose) % {{{
 
 		%BEGINVERB2BIN
@@ -85,5 +85,5 @@
 		end
 		%}}}
-		function verbose=BinaryToVerbose(verbose,binary) % {{{1
+		function verbose=BinaryToVerbose(verbose,binary) % {{{
 
 		%BEGINBIN2VERB
@@ -99,8 +99,8 @@
 		end
 		%}}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 		end % }}}
-		function disp(verbose) % {{{1
+		function disp(verbose) % {{{
 			
 		%BEGINDISP
Index: issm/branches/trunk-jpl-damage/src/m/enum/MaximumNumberOfEnums.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/enum/MaximumNumberOfEnums.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/enum/MaximumNumberOfEnums.m	(revision 12878)
@@ -9,3 +9,3 @@
 %      macro=MaximumNumberOfEnums()
 
-macro=439;
+macro=458;
